#include<bits/stdc++.h>
using namespace std;

int main()
{
    int n, o, a, b, ab;
    cin>>n>>o>>a>>b>>ab;
    vector<vector<int>> pac;
    for(int i=0;i<n;i++)
    {
        pac.push_back(*(new vector<int>));
        string c;
        cin>>c;
        if(c == "O")
            pac[i].push_back(0);
        if(c == "A")
            pac[i].push_back(1);
        if(c == "B")
            pac[i].push_back(2);
        if(c == "AB")
            pac[i].push_back(3);
        int x;
        cin>>x;
        pac[i].push_back(x);
    }



    for(int i=0;i<n;i++)
    {
        if(pac[i][0] == 0)
        {
            o-=pac[i][1];
            pac[i].push_back(pac[i][1]);
            pac[i].push_back(0);
            pac[i].push_back(0);
            pac[i].push_back(0);
        }
    }
    if(o<0)
    {
        cout<<"nemoguce"<<endl;
        return 0;
    }



    for(int i=0;i<n;i++)
    {
        if(pac[i][0] == 1)
        {
            if(a>=pac[i][1])
            {
                a -= pac[i][1];
                pac[i].push_back(0);
                pac[i].push_back(pac[i][1]);
                pac[i].push_back(0);
                pac[i].push_back(0);
            }
            else
            {
                o -= pac[i][1] - a;
                pac[i].push_back(pac[i][1]-a);
                pac[i].push_back(a);
                a=0;
                pac[i].push_back(0);
                pac[i].push_back(0);
            }
        }
        if(pac[i][0] == 2)
        {
            if(b>=pac[i][1])
            {
                b -= pac[i][1];
                pac[i].push_back(0);
                pac[i].push_back(0);
                pac[i].push_back(pac[i][1]);
                pac[i].push_back(0);
            }
            else
            {
                o -= pac[i][1] - b;
                pac[i].push_back(pac[i][1]-b);
                pac[i].push_back(b);
                b=0;
                pac[i].push_back(0);
                pac[i].push_back(0);
            }
        }
    }

    if(o<0 || a<0 || b<0)
    {
        cout<<"nemoguce"<<endl;
        return 0;
    }

    for(int i=0;i<n;i++)
    {
        if(pac[i][0] == 3)
        {
            pac[i].push_back(0);
            pac[i].push_back(0);
            pac[i].push_back(0);
            pac[i].push_back(0);
            if(ab>=pac[i][1])
            {
                ab-=pac[i][1];
                pac[i][5] = pac[i][1];
                continue;
            }
            else if(ab>0)
            {
                pac[i][1]-=ab;
                pac[i][5]+=ab;
                ab=0;
            }

            if(b>=pac[i][1])
            {
                b-=pac[i][1];
                pac[i][4] = pac[i][1];
                continue;
            }
            else if(b>0)
            {
                pac[i][1]-=b;
                pac[i][4]+=b;
                b=0;
            }

            if(a>=pac[i][1])
            {
                a-=pac[i][1];
                pac[i][3] = pac[i][1];
                continue;
            }
            else if(a>0)
            {
                pac[i][1]-=a;
                pac[i][3]+=a;
                a=0;
            }
            if(o>=pac[i][1])
            {
                o-=pac[i][1];
                pac[i][2] = pac[i][1];
                continue;
            }
            else
            {
                cout<<"nemoguce"<<endl;
                return 0;
            }
        }

    }
    cout<<"moguce"<<endl;
    for(int i=0;i<n;i++)
    {
        cout<<pac[i][2]<<' '<<pac[i][3]<<' '<<pac[i][4]<<' '<<pac[i][5]<<endl;
    }
    return 0;
}